package com.ruoyi.biemo.business.domain;

import com.ruoyi.biemo.elasticsearch.annotation.EsId;
import com.ruoyi.biemo.elasticsearch.annotation.FieldInfo;
import lombok.Data;
import org.springframework.data.elasticsearch.annotations.Document;

import java.util.List;


@Data
@Document(indexName = "doc_info")
@org.springframework.data.mongodb.core.mapping.Document("doc_info")
public class DocInfo extends BiemoEntity {
  private static final long serialVersionUID = 1L;

  @EsId
  private String id;
  @FieldInfo(type = "string",participle = 3)
  private String title;
  //文档类别 1:新闻、2:公众号
  @FieldInfo(type = "keyword",participle = 0)
  private Integer type;
  @FieldInfo(type = "keyword",participle = 0)
  private String thumb;
  @FieldInfo(type = "string",participle = 3)
  private String content;
  @FieldInfo(type = "keyword",participle = 0)
  private String author;
  @FieldInfo(type = "keyword",participle = 0)
  private String source;
  @FieldInfo(type = "keyword",participle = 0)
  private String url;
  @FieldInfo(type = "long",participle = 0)
  private Long click;
  @FieldInfo(type = "keyword",participle = 0)
  private String summary;
  @FieldInfo(type = "keyword",participle = 0)
  private Integer status;
  @FieldInfo(type = "long",participle = 0)
  private Long score;
  @FieldInfo(type = "keyword",participle = 0)
  private String cateId;
  @FieldInfo(type = "keyword",participle = 0)
  private Integer disabled;
  @FieldInfo(type = "keyword",participle = 0)
  private Integer deleted;
  @FieldInfo(type = "keyword",participle = 0)
  private Integer isSync;
  @FieldInfo(type = "keyword",participle = 0)
  private Integer hot;
  @FieldInfo(type = "keyword",participle = 0)
  private Integer recommend;
  //图谱数据
  private String parserGraphData;
  //命名实体数据
  private String parserNamedEntity;
  //情感数据
  private String parserEmotion;

  private String cateName;

  //分词数据
  private List<String> analyzeTitle;

  //分词状态 已分词 和未分词
  private String splitWordStatus;

  //词性标注状态 已标注 未标注
  private String posTagStatus;

}
