package com.ruoyi.biemo.business.domain;

import com.ruoyi.biemo.elasticsearch.annotation.EsId;
import com.ruoyi.biemo.elasticsearch.annotation.FieldInfo;
import com.ruoyi.common.core.domain.entity.SysDept;
import com.ruoyi.common.core.domain.entity.SysUser;
import lombok.Data;
import org.apache.commons.lang3.builder.ToStringBuilder;
import org.apache.commons.lang3.builder.ToStringStyle;
import com.ruoyi.common.annotation.Excel;
import com.ruoyi.common.core.domain.BaseEntity;
import org.springframework.data.elasticsearch.annotations.Document;

import java.io.Serializable;
import java.util.List;
import java.util.Map;

/**
 * 报告提交对象 report
 *
 * @author makesoft
 * @date 2022-09-18
 */
@Data
@Document(indexName = "report")
@org.springframework.data.mongodb.core.mapping.Document("report")
public class Report extends BiemoEntity {
    /**
     * 主键
     */
    @EsId
    private String id;
    /**
     * 报告名称
     */
    @FieldInfo(type = "string", participle = 3)
    private String title;


    @FieldInfo(type = "keyword",participle = 0)
    private Integer isSync;
    /**
     * 状态
     */
    @FieldInfo(type = "keyword", participle = 0)
    private Long status;
    /**
     * 报告编号
     */
    @FieldInfo(type = "keyword", participle = 0)
    private String reportNo;
    private String accessToken;
    private String appId;
    private Long endTime;
    private Map extData;
    private String groupId;
    private String groupMembers;
    private String groupName;
    private String openId;
    private String originId;
    private String roleInGroup;
    private Long score;
    private String signature;
    private Long startTime;
    private Long timeUsed;
    private List<ReportStep> steps;
}
